;
; Drive Motor Control Structure
;
; Current and Desired position drive the digital filter.
;
CurrentPosition = 0     ; Encoder driven value (Signed 32 bits)
;
; Motion Control data
;
PositionSetPoint= 4     ; 32 bit signed number
AccelSetPoint   = 8     ; 8.8 signed number >=0
VelocitySetPoint= 10    ; 8.8 signed number >=0
CurrentVelocity = 12    ; 8.8 signed number
DesiredPosition = 14    ; 32.8 signed number
ControlFlags    = 19    ; Position vs Velocity control
IntegralAcceleration= 20; 16.8 signed Distance to decelerate
DerivativeCounter= 23
;
; Digital Filter parameters
;
Kproportional   = 24
Kderivative     = 26    ; sample period of up to 1:256 main loop
Kintegral       = 28    ; This is divided by 256
IntegralLimit   = 30
DerivativeSampleRate = 32
;
;Keep the above together for initialization from EEPROM
;
IntegralError   = 33
PrevPositionError=35    ; Pe[n'-1]
DerivativeError = 37    ; Derivitive Error * Kdd


MotorStruct     = 39

;
; Flags
;
PWM9BIT         = 0     ; Bit number, not mask!!!
PWM10BIT        = 1
VELOCITY        = 2

