;
; Absolute code segment used to generate data for
; initializing the EEPROM in the AVR chips
;
        MODULE  MOTORCONTROLEEPROM

        PUBLIC  SysCycleTime SysFilterSize

        PUBLIC  RightEyeAdjustment LeftEyeAdjustment
        PUBLIC  LightCycleTime

        EXTERN  TICKRATE 

        RSEG    EEPROM
;
; EEPROM data for tweaking/adapting
;
; Use DB to preserve Big Endian used throught the schedular.
; DW lays stuff down little endian...
;
;++++++++++++++++++++++++++++++++++++++++++++++++++
;
; MotorControl
;
CycleTime       =       TICKRATE*17/10000       ; < 1.6 milliseconds

SysCycleTime:   DB      high(CycleTime), Low(CycleTime)
;
; Initial values for the digital filter...
;
SysLeftFilter:
                DB     0x00,0x20        ; KProportional
                DB     0x01,0x00        ; KDerivative
                DB     0x20,0x00        ; KIntegral
                DB     0x01,0x00        ; IntegralLimit
                DB     0x08             ; DerivativeSampleRate
SysFilterSize   =       $-SysLeftFilter
SysRightFilter:
                DB     0x00,0x20        ; KProportional
                DB     0x01,0x00        ; KDerivative
                DB     0x20,0x00        ; KIntegral
                DB     0x01,0x00        ; IntegralLimit
                DB     0x08             ; DerivativeSampleRate

; Analog Slope/Intercept adjustments
;
RightEyeAdjustment:
                DB      0,3
LeftEyeAdjustment:
                DB      0,3
;
; Light Seek Parameters
;
LightCycle      =       TICKRATE/10

LightCycleTime: DB      high(LightCycle), low(LightCycle)
                
        END
