;
; Hitachi LCD Control routines for industry standard LCD controllers.
; 
; The following equates need to be changed to match your hardware.  This
; code assumes an 4 bit interface.  The data port is the low nibble of the 
; selected output port.  The control bits can be any three bits of any port.
; 
; The following equates need to be changed to match your hardware.
;
LCD_DATA_OUT:	=	PORTC
LCD_DATA_DDR:	=	DDRC
LCD_DATA_IN:	=	PINC

LCD_CTL:	=	PORTC
LCD_CTL_DDR:	=	DDRC
	LCD_RS:	= PC4
	LCD_RW:	= PC5
	LCD_E:	= PC6
;
; Initialize ports...
;
LCD_CTL_DDR_INIT: = 1<<LCD_RS | 1<<LCD_RW | 1<<LCD_E

LCD_DELAY	MACRO	; number of delay cycles
	rjmp	$+2	;  4 mhz = 0
;	rjmp	$+2	;  8 mhz = 1
;	rjmp	$+2	; 16 mhz = 3
;	rjmp	$+2	; 20 mhz = 4

	ENDM
;
;
; Instructions/bits.  NB: Busy Flag (BF) is a bit, not a mask.
;
LCD_CLEAR:	=	(1<<0)
LCD_HOME:	=	(1<<1)
LCD_ENTRY:	=	(1<<2)
	LCD_ID:	=	1<<1	; Decrement/Increment Cursor 
	LCD_S:	=	1<<0	; Display No Shift/Shift
LCD_DISPLAY:	=	(1<<3)
	LCD_D:	=	1<<2	; Display off/on
	LCD_C:	=	1<<1	; Cursor off/On
	LCD_B:	=	1<<0	; Cursor No Blink/Blink
LCD_SHIFT:	=	(1<<4)
	LCD_CL:	=	1<<3	; Shift Cursor/Display
	LCD_RL:	=	1<<2	; Shift Left/Right
LCD_FUNC:	=	(1<<5)
	LCD_DL:	=	1<<4	; 4/8 bit interface
	LCD_N:	=	1<<3	; 1/2 line display
	LCD_F:	=	1<<2	; 5x7/5/10 dot charactor
LCD_SET_CGRAM:	=	(1<<6)
LCD_SET_DDRAM:	=	(1<<7)
;
; Reading an instruction gives you the current address counter and 
; the busy flag.
;
LCD_ADDR:	=	0x07		; Mask for address upper nibble
LCD_BF:		=	3		; Busy flag (MSB)
;
; Define your LCD display type here:
;
; Set LCD to 4 bit i/f, two lines
;
LCD_FUNCTION_SET: = LCD_FUNC | LCD_N
;
; Turn display on, with cursor and make cursor blinking
;
LCD_DISPLAY_SET: = LCD_DISPLAY | LCD_D | LCD_C | LCD_B
;
; Misc commands that are useful
;
LCD_Next_Line:	= LCD_SET_DDRAM | 0x40	; Start of second line

